<?php
/**
 * User: nester_a
 * Date: 29.10.13
 */

namespace Webex\Repository;

use LMS\Tools\Conference\Repository;

class Record extends Repository\Record
{

    public function __construct($db)
    {
        parent::__construct($db);
    }


    /**
     * Returns record of conference specified by $sessioname
     *
     * @param string $sessionName
     * @return int mixed
     */
    public function getBySessionName($sessionName)
    {
        $query = "SELECT `rec`.*, rfile.filepath as filename FROM `#__lms_conference_records` `rec`
                    LEFT JOIN
                        #__lms_conference_record_files_webex rfile
                        ON rfile.record_id = rec.id
                    WHERE session_name = '".$sessionName."' ";
        $this->db->setQuery($query);
        return $this->db->loadObject();
    }

    /**
     * @param $recordID
     * @param $filename
     * @return mixed
     */
    public function saveFile($recordID, $filename)
    {
        $query = "INSERT INTO
                        #__lms_conference_record_files_webex
                        (record_id, filepath)
                    VALUES
                        ('".$recordID."', " . $this->db->quote($filename) . ")";
        $this->db->setQuery($query);
        return $this->db->query();
    }
}