CREATE TABLE IF NOT EXISTS `#__lms_conference_oauth` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `user_id`int(11) NOT NULL,
  `token` varchar(255) NOT NULL,
  `expires_in` varchar(255) NOT NULL,
  `refresh_token` varchar(255) NOT NULL,
  `organizer_key` varchar(255) NOT NULL,
  `account_key` varchar(255) NOT NULL,
  `account_type` varchar(255) NOT NULL,
  `created` timestamp NOT NULL DEFAULT CURRENT_TIMESTAMP ON UPDATE CURRENT_TIMESTAMP,
  PRIMARY KEY (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__lms_conference_gtm` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `conf_id` int(11) NOT NULL,
  `meeting_id` varchar(255) NOT NULL,
  `unique_meeting_id` varchar(255) NOT NULL,
  `join_url` varchar(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `unique_meeting_id` (`unique_meeting_id`),
  KEY `meeting_id` (`meeting_id`),
  KEY `conf_id` (`conf_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;

CREATE TABLE IF NOT EXISTS `#__lms_conference_record_files_gtm` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `record_id` int(11) NOT NULL,
  `filepath` VARCHAR(255) NOT NULL,
  PRIMARY KEY (`id`),
  KEY `record_id` (`record_id`)
) ENGINE=InnoDB  DEFAULT CHARSET=utf8 AUTO_INCREMENT=1 ;
